"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DictionariesActionBuilder = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var util_1 = require("../util");
var definition_1 = require("../definition");
/**
 * @action-builder
 * @stable [08.09.2020]
 */
var DictionariesActionBuilder = /** @class */ (function () {
    function DictionariesActionBuilder() {
    }
    /**
     * @stable [08.09.2020]
     * @param section
     */
    DictionariesActionBuilder.buildLoadActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.DICTIONARY_LOAD_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     */
    DictionariesActionBuilder.buildDestroyActionType = function () {
        return util_1.SectionUtils.actionPrefix('all') + "." + definition_1.DICTIONARY_DESTROY_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    DictionariesActionBuilder.buildLoadDoneActionType = function (section) {
        return redux_effects_promise_1.EffectsActionBuilder.buildDoneActionType(util_1.SectionUtils.actionPrefix(section) + "." + definition_1.DICTIONARY_LOAD_ACTION_TYPE);
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    DictionariesActionBuilder.buildLoadErrorActionType = function (section) {
        return redux_effects_promise_1.EffectsActionBuilder.buildErrorActionType(util_1.SectionUtils.actionPrefix(section) + "." + definition_1.DICTIONARY_LOAD_ACTION_TYPE);
    };
    /**
     * @stable [08.09.2020]
     * @param section
     */
    DictionariesActionBuilder.buildSetActionType = function (section) {
        return util_1.SectionUtils.actionPrefix(section) + "." + definition_1.DICTIONARY_SET_ACTION_TYPE;
    };
    /**
     * @stable [08.09.2020]
     */
    DictionariesActionBuilder.buildDestroyAction = function () {
        return redux_effects_promise_1.EffectsAction.create(DictionariesActionBuilder.buildDestroyActionType());
    };
    /**
     * @stable [08.09.2020]
     * @param section
     * @param data
     */
    DictionariesActionBuilder.buildLoadAction = function (section, data) {
        var plainAction = this.buildLoadPlainAction(section, data);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    /**
     * @stable [08.09.2020]
     * @param section
     * @param data
     */
    DictionariesActionBuilder.buildSetAction = function (section, data) {
        var plainAction = this.buildSetPlainAction(section, data);
        return redux_effects_promise_1.EffectsAction.create(plainAction.type, plainAction.data);
    };
    /**
     * @stable [08.09.2020]
     * @param section
     * @param data
     */
    DictionariesActionBuilder.buildLoadPlainAction = function (section, data) {
        return {
            type: this.buildLoadActionType(section),
            data: util_1.SectionUtils.applySection(section, data),
        };
    };
    /**
     * @stable [08.09.2020]
     * @param section
     * @param data
     */
    DictionariesActionBuilder.buildSetPlainAction = function (section, data) {
        return {
            type: this.buildSetActionType(section),
            data: util_1.SectionUtils.applySection(section, data),
        };
    };
    return DictionariesActionBuilder;
}());
exports.DictionariesActionBuilder = DictionariesActionBuilder;
//# sourceMappingURL=dictionaries-action.builder.js.map