import * as BPromise from 'bluebird';
import { IAsyncLibConfigEntity, IAsyncLibManager } from '../definition';
import { AnyT } from '../definitions.interface';
export declare class AsyncLibManager implements IAsyncLibManager {
    private readonly domAccessor;
    private readonly store;
    private readonly scriptsTasks;
    private readonly registeredLibs;
    /**
     * @stable [09.01.2020]
     * @param {IAsyncLibConfigEntity} cfg
     */
    registerLib(cfg: IAsyncLibConfigEntity): void;
    /**
     * @stable [08.01.2020]
     * @param {IAsyncLibConfigEntity} cfg
     * @returns {Promise<HTMLScriptElement>}
     */
    loadLib(cfg: IAsyncLibConfigEntity): Promise<HTMLScriptElement>;
    /**
     * @stable [09.01.2020]
     * @param {IAsyncLibConfigEntity} cfg
     * @returns {Bluebird<HTMLScriptElement>}
     */
    waitForLib(cfg: IAsyncLibConfigEntity): BPromise<HTMLScriptElement> | AnyT;
    /**
     * @stable [10.01.2020]
     * @param {Bluebird<HTMLScriptElement> | AnyT} promise
     * @returns {boolean}
     */
    cancelWaiting(promise: BPromise<HTMLScriptElement> | AnyT): boolean;
}
