import { CommandParam } from './command.param';
/**
 * @stable [08.11.20]
 */
export declare class Command {
    static readonly $PROTOCOL_PAYLOAD_CLASS_IDENTIFIER = "Command";
    /**
     * @stable [21.05.2018]
     * @returns {Command}
     */
    static newCommand(): Command;
    private command;
    private params;
    private uuid;
    /**
     * @stable [08.11.2020]
     * @param $uuid
     */
    setUuid($uuid: string): Command;
    /**
     * @stable [21.05.2018]
     * @param {string} command
     * @returns {Command}
     */
    setCommand(command: string): Command;
    /**
     * @stable [21.05.2018]
     * @param {string} paramName
     * @param {AnyT} paramValue
     * @returns {Command}
     */
    addParam(paramName: string, paramValue: unknown): Command;
    /**
     * @stable [21.05.2018]
     * @returns {string}
     */
    getCommand(): string;
    /**
     * @stable [21.05.2018]
     * @returns {string}
     */
    getUuid(): string;
    /**
     * @stable [21.05.2018]
     * @returns {CommandParam[]}
     */
    getParams(): CommandParam[];
}
