"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignalRChannel = void 0;
var signalR = require("@microsoft/signalr");
var inversify_1 = require("inversify");
var ts_smart_logger_1 = require("ts-smart-logger");
var base_channel_service_1 = require("../base-channel.service");
var util_1 = require("../../util");
var definition_1 = require("../../definition");
/**
 * @service
 * @stable [04.11.2020]
 */
var SignalRChannel = /** @class */ (function (_super) {
    __extends(SignalRChannel, _super);
    /**
     * @stable [04.11.2020]
     */
    function SignalRChannel() {
        var _this = _super.call(this) || this;
        _this.onMessage = _this.onMessage.bind(_this);
        return _this;
    }
    SignalRChannel_1 = SignalRChannel;
    /**
     * @stable [04.11.2020]
     * @param ip
     * @param config
     */
    SignalRChannel.prototype.connect = function (ip, config) {
        return __awaiter(this, void 0, void 0, function () {
            var connection, disconnectCallback;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.hasClient(ip)) {
                            SignalRChannel_1.logger.info("[$SignalRChannel][connect] The client is already registered. Ip: " + ip);
                            return [2 /*return*/];
                        }
                        connection = new signalR.HubConnectionBuilder()
                            .withUrl(ip)
                            .withAutomaticReconnect(SignalRChannel_1.RETRY_DELAYS)
                            .build();
                        return [4 /*yield*/, this.registerClient(ip, {
                                on: function (event, callback) { return __awaiter(_this, void 0, void 0, function () {
                                    var _a;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                _a = event;
                                                switch (_a) {
                                                    case this.eventToListen: return [3 /*break*/, 1];
                                                    case definition_1.CHANNEL_CONNECT_EVENT: return [3 /*break*/, 2];
                                                    case definition_1.CHANNEL_DISCONNECT_EVENT: return [3 /*break*/, 4];
                                                }
                                                return [3 /*break*/, 5];
                                            case 1:
                                                connection.on(event, callback);
                                                return [3 /*break*/, 5];
                                            case 2:
                                                connection.onreconnecting(function () {
                                                    // The server is down
                                                    SignalRChannel_1.logger.info('[$SignalRChannel][connect][onreconnecting]');
                                                    if (util_1.TypeUtils.isFn(disconnectCallback)) {
                                                        disconnectCallback();
                                                    }
                                                });
                                                connection.onreconnected(function () {
                                                    SignalRChannel_1.logger.info('[$SignalRChannel][connect][onreconnected]');
                                                    callback();
                                                });
                                                return [4 /*yield*/, this.doConnect(connection, callback)];
                                            case 3:
                                                _b.sent();
                                                return [3 /*break*/, 5];
                                            case 4:
                                                disconnectCallback = callback;
                                                return [3 /*break*/, 5];
                                            case 5: return [2 /*return*/];
                                        }
                                    });
                                }); },
                                emit: function (event) {
                                    var args = [];
                                    for (var _i = 1; _i < arguments.length; _i++) {
                                        args[_i - 1] = arguments[_i];
                                    }
                                    return __awaiter(_this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, connection.send.apply(connection, __spreadArrays([event], args))];
                                                case 1:
                                                    _a.sent();
                                                    return [2 /*return*/];
                                            }
                                        });
                                    });
                                },
                                close: function () { return __awaiter(_this, void 0, void 0, function () {
                                    var e_1;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                this.stopReconnectTask(connection);
                                                this.setStopConnection(connection);
                                                _a.label = 1;
                                            case 1:
                                                _a.trys.push([1, 3, , 4]);
                                                return [4 /*yield*/, connection.stop()];
                                            case 2:
                                                _a.sent();
                                                return [3 /*break*/, 4];
                                            case 3:
                                                e_1 = _a.sent();
                                                SignalRChannel_1.logger.error('[$SignalRChannel][close] Error:', e_1);
                                                return [3 /*break*/, 4];
                                            case 4:
                                                if (util_1.TypeUtils.isFn(disconnectCallback)) {
                                                    disconnectCallback();
                                                }
                                                return [2 /*return*/];
                                        }
                                    });
                                }); },
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [06.11.2020]
     * @param connection
     * @param callback
     * @private
     */
    SignalRChannel.prototype.doConnect = function (connection, callback) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, connection.start()];
                    case 1:
                        _a.sent();
                        callback();
                        this.stopReconnectTask(connection);
                        return [3 /*break*/, 3];
                    case 2:
                        e_2 = _a.sent();
                        SignalRChannel_1.logger.error('[$SignalRChannel][connect] Error:', e_2);
                        if (!this.isConnectionStopped(connection)) {
                            this.tryReconnect(connection, callback);
                        }
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @stable [06.11.2020]
     * @private
     */
    SignalRChannel.prototype.tryReconnect = function (connection, callback) {
        var _this = this;
        SignalRChannel_1.logger.debug('[$SignalRChannel][tryReconnect] Connection:', connection);
        var reconnectTask = this.getReconnectTask(connection);
        util_1.ConditionUtils.ifNilThanValue(reconnectTask, function () {
            _this.setReconnectTask(connection, reconnectTask = new util_1.DelayedTask(function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!!this.isConnectionStopped(connection)) return [3 /*break*/, 2];
                            SignalRChannel_1.logger.debug('[$SignalRChannel][tryReconnect] Task. Connection:', connection);
                            return [4 /*yield*/, this.doConnect(connection, callback)];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            }); }, 2000));
        });
        reconnectTask.start();
    };
    /**
     * @stable [07.11.2020]
     * @param connection
     * @private
     */
    SignalRChannel.prototype.stopReconnectTask = function (connection) {
        var _this = this;
        util_1.ConditionUtils.ifNotNilThanValue(this.getReconnectTask(connection), function (reconnectTask) {
            reconnectTask.stop();
            _this.setReconnectTask(connection, null);
        });
    };
    /**
     * @stable [06.11.2020]
     * @param connection
     * @private
     */
    SignalRChannel.prototype.getReconnectTask = function (connection) {
        return Reflect.get(connection, SignalRChannel_1.$$RECONNECT_TASK);
    };
    /**
     * @stable [07.11.2020]
     * @param connection
     * @param task
     * @private
     */
    SignalRChannel.prototype.setReconnectTask = function (connection, task) {
        Reflect.set(connection, SignalRChannel_1.$$RECONNECT_TASK, task);
    };
    /**
     * @stable [07.11.2020]
     * @param connection
     * @private
     */
    SignalRChannel.prototype.setStopConnection = function (connection) {
        Reflect.set(connection, SignalRChannel_1.$$CONNECTION_STOPPED, true);
    };
    /**
     * @stable [07.11.2020]
     * @param connection
     * @private
     */
    SignalRChannel.prototype.isConnectionStopped = function (connection) {
        return !!Reflect.get(connection, SignalRChannel_1.$$CONNECTION_STOPPED);
    };
    var SignalRChannel_1;
    SignalRChannel.logger = ts_smart_logger_1.LoggerFactory.makeLogger('SignalRChannel');
    SignalRChannel.$$CONNECTION_STOPPED = '$$connectionStopped';
    SignalRChannel.$$RECONNECT_TASK = '$$reconnectTask';
    SignalRChannel.RETRY_DELAYS = util_1.ArrayUtils
        .makeArray(500)
        .map(function (_, index) { return Math.round(index * 1.2 * 1000); })
        .concat(null);
    SignalRChannel = SignalRChannel_1 = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], SignalRChannel);
    return SignalRChannel;
}(base_channel_service_1.BaseChannel));
exports.SignalRChannel = SignalRChannel;
//# sourceMappingURL=signalr-channel.service.js.map