"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.applicationReducer = void 0;
var application_action_builder_1 = require("./application-action.builder");
var definition_1 = require("../../definition");
var util_1 = require("../../util");
function applicationReducer(state, action) {
    if (state === void 0) { state = definition_1.INITIAL_UNIVERSAL_APPLICATION_ENTITY; }
    switch (action.type) {
        case definition_1.$RAC_APPLICATION_PREPARE_ACTION_TYPE:
            return __assign(__assign({}, state), { ready: false, progress: true, error: null });
        case application_action_builder_1.ApplicationActionBuilder.buildPathActionType():
            return __assign(__assign({}, state), { path: action.data });
        case definition_1.$RAC_APPLICATION_CUSTOM_ERROR_ACTION_TYPE:
        case definition_1.$RAC_APPLICATION_PREPARE_ERROR_ACTION_TYPE:
            return __assign(__assign({}, state), { customError: action.type === definition_1.$RAC_APPLICATION_CUSTOM_ERROR_ACTION_TYPE, progress: false, error: util_1.asErrorMessage(action.error).message });
        case definition_1.$RAC_APPLICATION_READY_ACTION_TYPE:
            return __assign(__assign({}, state), { error: null, progress: false, ready: true });
        case definition_1.$RAC_APPLICATION_NOT_READY_ACTION_TYPE:
            return __assign(__assign({}, state), { ready: false });
        case application_action_builder_1.ApplicationActionBuilder.buildAuthorizedActionType():
            return __assign(__assign({}, state), { authorized: true });
        case application_action_builder_1.ApplicationActionBuilder.buildUnauthorizedActionType():
            return __assign(__assign({}, state), { authorized: false });
    }
    return state;
}
exports.applicationReducer = applicationReducer;
//# sourceMappingURL=application.reducer.js.map