import { AnyT } from '../../definitions.interface';
import { GenericPluginCtorT, IEnhancedGenericComponentProps, IGenericPlugin } from '../../definition';
import { GenericComponent } from './generic.component';
export declare class EnhancedGenericComponent<TProps extends IEnhancedGenericComponentProps = IEnhancedGenericComponentProps, TState = {}, TSelfRef = AnyT> extends GenericComponent<TProps, TState, TSelfRef> {
    protected readonly plugins: IGenericPlugin[];
    private $uiPlugins;
    /**
     * @stable [19.09.2020]
     * @param originalProps
     */
    constructor(originalProps: TProps);
    /**
     * @stable [19.09.2020]
     */
    componentDidMount(): void;
    /**
     * @stable [21.04.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [19.09.2020]
     * @param prevProps
     * @param prevState
     * @param prevContext
     */
    componentDidUpdate(prevProps: Readonly<TProps>, prevState: Readonly<TState>, prevContext?: never): void;
    /**
     * @stable [19.09.2020]
     * @param prevProps
     * @param prevState
     */
    getSnapshotBeforeUpdate(prevProps: Readonly<TProps>, prevState: Readonly<TState>): void;
    /**
     * @stable [19.09.2020]
     * @param pluginObject
     */
    protected registerPlugin(pluginObject: GenericPluginCtorT | IGenericPlugin): void;
    /**
     * @stable [21.04.2020]
     */
    private initPlugins;
    /**
     * @stable [19.09.2020]
     */
    private get uiPlugins();
}
