/// <reference types="react" />
import { GenericComponent } from '../base/generic.component';
import { IKeyInterceptorProps } from './key-interceptor.interface';
export declare class KeyInterceptor extends GenericComponent<IKeyInterceptorProps> {
    static readonly defaultProps: IKeyInterceptorProps;
    private static readonly logger;
    private static IOS12_SAFARI_CAPTURE_EVENT;
    private static DEFAULT_CAPTURE_EVENT;
    private static ENTER_KEY_CODES;
    private static SPECIAL_KEY_CODES;
    private delayedTask;
    private unSubscriber;
    private buffer;
    /**
     * @stable [05.05.2018]
     * @param props
     */
    constructor(props: any);
    /**
     * @stable [18.05.2020]
     */
    componentDidMount(): void;
    /**
     * @stable [18.05.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [08.10.2019]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [08.10.2019]
     * @param {KeyboardEvent} e
     */
    private onEventCapture;
    /**
     * @stable [08.10.2019]
     */
    private onCheckBuffer;
    /**
     * @stable [11.09.2019]
     * @returns {string}
     */
    private get captureEvent();
    /**
     * @stable [08.10.2019]
     * @returns {boolean}
     */
    private get isCaptureFilterDisabled();
}
