"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultLayoutViewBuilder = void 0;
var util_1 = require("../../../util");
var universal_layout_view_builder_1 = require("./universal-layout-view.builder");
var DefaultLayoutViewBuilder = /** @class */ (function (_super) {
    __extends(DefaultLayoutViewBuilder, _super);
    function DefaultLayoutViewBuilder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [23.01.2020]
     * @param {{}} props
     * @param {Array<UniversalLayoutBuilderChildrenT<JSX.Element>>} children
     * @param {IUniversalLayoutBuilderConfigEntity<JSX.Element>} layoutConfig
     * @returns {AnyT}
     */
    DefaultLayoutViewBuilder.prototype.buildRowView = function (props, children, layoutConfig) {
        return __assign(__assign({}, layoutConfig.factor ? { factor: layoutConfig.factor } : {}), { columns: children });
    };
    /**
     * @stable [23.01.2020]
     * @param {{}} props
     * @param {Array<UniversalLayoutBuilderChildrenT<JSX.Element>>} children
     * @param {IUniversalLayoutBuilderConfigEntity<JSX.Element>} layoutConfig
     * @returns {AnyT}
     */
    DefaultLayoutViewBuilder.prototype.buildColumnView = function (props, children, layoutConfig) {
        return __assign(__assign({}, layoutConfig.factor ? { factor: layoutConfig.factor } : {}), { rows: children });
    };
    /**
     * @stable [23.01.2020]
     * @param {UniversalLayoutBuilderChildrenT<JSX.Element>} item
     * @returns {boolean}
     */
    DefaultLayoutViewBuilder.prototype.isClonedItem = function (item) {
        return util_1.isDef(item.props);
    };
    return DefaultLayoutViewBuilder;
}(universal_layout_view_builder_1.UniversalLayoutViewBuilder));
exports.DefaultLayoutViewBuilder = DefaultLayoutViewBuilder;
//# sourceMappingURL=default-layout-view.builder.js.map