/// <reference types="react" />
import { IMenuProps, IMenuState } from '../../definition';
import { GenericComponent } from '../base/generic.component';
export declare class Menu extends GenericComponent<IMenuProps, IMenuState> {
    static readonly defaultProps: IMenuProps;
    private readonly dialogRef;
    private readonly fieldRef;
    private readonly listElementRef;
    private filterQueryTask;
    private scrollEventUnsubscriber;
    private resizeUnsubscriber;
    /**
     * @stable [08.08.2020]
     * @param originalProps
     */
    constructor(originalProps: IMenuProps);
    /**
     * @stable [24.01.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [18.06.2019]
     */
    componentWillUnmount(): void;
    /**
     * @stable [31.01.2020]
     * @param {() => void} callback
     */
    show(callback?: () => void): void;
    /**
     * @stable [09.08.2020]
     */
    hide(): void;
    /**
     * @stable [08.08.2020]
     */
    isOpen(): boolean;
    /**
     * @stable [07.08.2020]
     * @private
     */
    private notifyFilterChange;
    /**
     * @stable [08.08.2020]
     * @param filter
     * @private
     */
    private onFilterValueChange;
    /**
     * @stable [09.08.2020]
     * @param option
     * @private
     */
    private onSelect;
    /**
     * @stable [09.08.2020]
     * @private
     */
    private onDialogActivate;
    /**
     * @stable [08.08.2020]
     * @private
     */
    private onDialogDeactivate;
    /**
     * @stable [25.01.2020]
     */
    private onDialogAfterRender;
    /**
     * @stable [25.01.2020]
     */
    private onDialogAfterDestroy;
    /**
     * @stable [24.01.2020]
     * @returns {JSX.Element}
     */
    private get listElement();
    /**
     * @stable [18.08.2020]
     * @param option
     * @param index
     * @param length
     */
    private asItemElement;
    /**
     * @stable [09.08.2020]
     * @private
     */
    private get inlineOptionsElement();
    /**
     * @stable [09.08.2020]
     * @private
     */
    private get applyActionsElement();
    /**
     * @stable [09.08.2020]
     * @private
     */
    private get filterElement();
    /**
     * @stable [08.08.2020]
     * @private
     */
    private get closeActionElement();
    /**
     * @stable [08.08.2020]
     * @param element
     * @private
     */
    private scrollEventCallbackCondition;
    /**
     * @stable [08.08.2020]
     */
    private clearAll;
    /**
     * @stable [08.08.2020]
     */
    private unsubscribeAllEvents;
    /**
     * @stable [09.08.2020]
     * @private
     */
    private get items();
    /**
     * @stable [08.08.2020]
     * @private
     */
    private get isFilterUsed();
    /**
     * @stable [08.08.2020]
     * @private
     */
    private get isAnchored();
    /**
     * @stable [08.08.2020]
     * @private
     */
    private get field();
    /**
     * @stable [08.08.2020]
     * @private
     */
    private get dialog();
}
