import * as React from 'react';
import { StoreProxy } from '../store.proxy';
import { IGenericContainer, IGenericContainerProps, IReduxStoreEntity, IRouterStoreProxy, IRouterStoreProxyFactoryConfigEntity } from '../../../../definition';
export declare class RouterStoreProxy<TStore extends IReduxStoreEntity = IReduxStoreEntity, TProps extends IGenericContainerProps = IGenericContainerProps> extends StoreProxy<TStore, TProps> implements IRouterStoreProxy {
    readonly container: IGenericContainer<TProps>;
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    constructor(container: IGenericContainer<TProps>);
    /**
     * @stable [06.02.2020]
     * @param {string} path
     */
    navigate(path: string): void;
    /**
     * @stable [30.03.2020]
     * @param {string} path
     */
    rewrite(path: string): void;
    /**
     * @stable [20.12.2019]
     * @param {number} depth
     */
    goBack(depth?: number): void;
    /**
     * @stable [20.12.2019]
     */
    navigateBack(): void;
    /**
     * @stable [22.05.2020]
     * @param {(cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element} factory
     * @returns {React.ReactNode[]}
     */
    buildNavigationSteps(factory: (cfg: IRouterStoreProxyFactoryConfigEntity) => JSX.Element): React.ReactNode[];
}
