import { IGenericContainer, IGenericContainerProps, IReduxStoreEntity, ITabPanelStoreProxy } from '../../../../definition';
import { StoreProxy } from '../store.proxy';
export declare class TabPanelStoreProxy<TStore extends IReduxStoreEntity = IReduxStoreEntity, TProps extends IGenericContainerProps = IGenericContainerProps> extends StoreProxy<TStore, TProps> implements ITabPanelStoreProxy {
    readonly container: IGenericContainer<TProps>;
    /**
     * @stable [30.03.2020]
     * @param {IGenericContainer<TProps extends IGenericContainerProps>} container
     */
    constructor(container: IGenericContainer<TProps>);
    /**
     * @stable [12.04.2020]
     * @param {number} payload
     * @param {string} otherSection
     */
    dispatchTabPanelActiveValue(payload: number, otherSection?: string): void;
    /**
     * @stable [12.04.2020]
     * @param {number} payload
     * @param {string} otherSection
     */
    dispatchTabPanelInactiveValue(payload: number, otherSection?: string): void;
    /**
     * @stable [12.04.2020]
     * @param {string} otherSection
     */
    dispatchTabPanelDestroy(otherSection?: string): void;
}
