"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebCamera = void 0;
var React = require("react");
var Webcam = require("webcamjs");
var generic_component_1 = require("../base/generic.component");
var util_1 = require("../../util");
var WebCamera = /** @class */ (function (_super) {
    __extends(WebCamera, _super);
    /**
     * @stable [02.11.2020]
     * @param originalProps
     */
    function WebCamera(originalProps) {
        var _this = _super.call(this, originalProps) || this;
        _this.$isMounted = false;
        _this.$isCameraLive = false;
        _this.onCapture = _this.onCapture.bind(_this);
        _this.onLive = _this.onLive.bind(_this);
        Webcam.set({
            width: originalProps.width,
            height: originalProps.height,
            image_format: 'jpeg',
            jpeg_quality: 100,
        });
        return _this;
    }
    /**
     * @stable [02.11.2020]
     */
    WebCamera.prototype.componentDidMount = function () {
        Webcam.attach("#" + WebCamera.CAMERA_ID);
        Webcam.on('live', this.onLive);
        this.$isMounted = true;
    };
    /**
     * @stable [02.11.2020]
     */
    WebCamera.prototype.componentWillUnmount = function () {
        this.reset();
        this.$isMounted = false;
    };
    /**
     * @stable [02.08.2018]
     * @returns {JSX.Element}
     */
    WebCamera.prototype.render = function () {
        return (React.createElement("div", { id: WebCamera.CAMERA_ID, className: 'rac-web-camera' }));
    };
    /**
     * @stable [02.11.2020]
     */
    WebCamera.prototype.capture = function () {
        Webcam.snap(this.onCapture);
    };
    /**
     * @stable [02.11.2020]
     * @param dataUri
     * @private
     */
    WebCamera.prototype.onCapture = function (dataUri) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, util_1.ConditionUtils.ifNotNilThanValue(this.originalProps.onSelect, function (onSelect) { return __awaiter(_this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                _a = onSelect;
                                return [4 /*yield*/, util_1.BlobUtils.fromUrlToBlob(dataUri)];
                            case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                        }
                    }); }); })];
            });
        });
    };
    /**
     * @stable [02.11.2020]
     * @private
     */
    WebCamera.prototype.reset = function () {
        if (this.$isCameraLive) {
            Webcam.reset();
            Webcam.off('live', this.onLive);
            this.$isCameraLive = false;
        }
    };
    /**
     * @stable [03.11.2020]
     * @private
     */
    WebCamera.prototype.onLive = function () {
        this.$isCameraLive = true;
        if (!this.$isMounted) {
            this.reset();
        }
    };
    WebCamera.defaultProps = {
        width: 360,
        height: 270,
    };
    WebCamera.CAMERA_ID = util_1.UuidUtils.uuid(true);
    return WebCamera;
}(generic_component_1.GenericComponent));
exports.WebCamera = WebCamera;
//# sourceMappingURL=web-camera.component.js.map