import { IPeriodWrapper, IReturnNeverExecutablePeriodAsEmptyValueWrapper } from '../definitions.interface';
/**
 * @stable [15.11.2019]
 */
export declare enum CronPartTypesEnum {
    DAY_OF_MONTH = 0,
    DAY_OF_WEEK = 1,
    HOUR = 2,
    MINUTE = 3,
    MONTH_OF_YEAR = 4,
    YEAR = 5
}
/**
 * @stable [15.12.2019]
 */
export declare enum CronPeriodsEnum {
    COMPLEX_RULE = 0,
    DAILY = 1,
    MONTHLY = 2,
    NO_REPETITIONS = 3,
    WEEKLY = 4,
    YEARLY = 5
}
/**
 * @stable [14.12.2019]
 */
export declare const CRON_ALL_VALUES_SYMBOL = "*";
export declare const CRON_LAST_DAY_OF_MONTH = 0;
export declare const CRON_LAST_DAY_SYMBOL = "L";
export declare const CRON_NEVER_EXECUTABLE_SYMBOL = "N";
/**
 * @stable [15.11.2019]
 */
export declare const CRON_PART_TYPE_RANGES: Readonly<{
    [cronPartType: string]: number[];
}>;
/**
 * @stable [14.12.2019]
 */
export declare const CRON_PART_TYPE_RANGES_VALUES: Readonly<{
    [cronPartType: string]: number[];
}>;
/**
 * @stable [14.12.2019]
 */
export declare const CRON_ALL_DAYS_OF_MONTH_VALUES: number[];
export declare const CRON_ALL_DAYS_OF_WEEK_VALUES: number[];
export declare const CRON_ALL_HOURS_VALUES: number[];
export declare const CRON_ALL_MINUTES_VALUES: number[];
export declare const CRON_ALL_MONTHS_OF_YEAR_VALUES: number[];
export declare const CRON_ALL_YEARS_VALUES: number[];
/**
 * @stable [15.12.2019]
 */
export interface ICronPlainEntity {
    allDaysOfMonth?: boolean;
    allDaysOfWeek?: boolean;
    allHours?: boolean;
    allMinutes?: boolean;
    allMonths?: boolean;
    allYears?: boolean;
    daysOfMonths: number[];
    daysOfWeeks: number[];
    hours: number[];
    minutes: number[];
    months: number[];
    years: number[];
}
/**
 * @stable [15.11.2019]
 */
export interface ICronEntity<TEntity extends ICronEntity = ICronEntity<TEntity>> extends ICronPlainEntity {
    addDaysOfMonths(...values: number[]): TEntity;
    addDaysOfWeeks(...values: number[]): TEntity;
    asPeriodType(): CronPeriodsEnum;
    asPlainObject(): ICronPlainEntity;
    excludeDaysOfMonths(...values: number[]): TEntity;
    excludeDaysOfWeeks(...values: number[]): TEntity;
    fromExpression(expression?: string): TEntity;
    hasDayOfMonth(value: number): boolean;
    hasDayOfWeek(value: number): boolean;
    toExpression(returnNeverExecutablePeriodAsEmptyValue?: boolean): string;
}
/**
 * @stable [15.12.2019]
 */
export interface IGenericCronEntity extends IPeriodWrapper<CronPeriodsEnum>, IReturnNeverExecutablePeriodAsEmptyValueWrapper {
}
