import { IAsyncLibrariesSettingsEntity, IComponentsSettingsEntity, ICurrencySettingsEntity, IDateTimeSettingsEntity, IElementsMarkersSettingsEntity, IGoogleMapsSettingsEntity, IMessagesSettingsEntity, INumberConverterSettingsEntity, IOAuthSettingsEntity, IPhoneSettingsEntity, IRoutesSettingsEntity, IStorageSettingsEntity, ITransportSettingsEntity, IUrlsSettingsEntity, StorageTypesEnum } from '../definition';
export interface IApplicationResourcePaths {
    uiDefaultIconPath?: string;
}
export interface IDateTimeSettings extends IDateTimeSettingsEntity {
    timeZone?: string;
    dateFormat?: string;
    timeFormat?: string;
    uiMonthFormat?: string;
    pstDateFormat?: string;
    pstTimeFormat?: string;
    uiTimeMask?: (string | RegExp)[];
    uiShortTimeMask?: (string | RegExp)[];
    uiTimePattern?: string;
    uiShortTimePattern?: string;
}
export interface IApplicationNumberSettings {
    uiPattern?: string;
}
/**
 * @stable [10.03.2019]
 */
export interface IMessagesSettings extends IMessagesSettingsEntity {
    acceptMessage?: string;
    accessDeniedMessage?: string;
    dataSaved?: string;
    emptyMessage?: string;
    errorMessage?: string;
    logoutNotificationMessage?: string;
    noItemsMessage?: string;
    requestCancelErrorMessage?: string;
    serviceTemporarilyUnavailableMessage?: string;
    sorryMessage?: string;
    waitingMessage?: string;
    waitMessage?: string;
}
export interface IAuthorizationSettings {
    isAuthorizationNeeded?: boolean;
}
export interface IApplicationChannelSettings {
    eventToListen?: string;
    eventToEmit?: string;
}
export interface IBootstrapSettings {
    flexEnabled?: boolean;
    rootId?: string;
}
export interface ISettingsEntity {
    asyncLibraries?: IAsyncLibrariesSettingsEntity;
    authorization?: IAuthorizationSettings;
    bootstrap?: IBootstrapSettings;
    channel?: IApplicationChannelSettings;
    companyName?: string;
    components?: IComponentsSettingsEntity;
    currency?: ICurrencySettingsEntity;
    dateTime?: IDateTimeSettings;
    downloadUrl?: string;
    elementsMarkers?: IElementsMarkersSettingsEntity;
    emptyPictureUrl?: string;
    googleMaps?: IGoogleMapsSettingsEntity;
    messages?: IMessagesSettings;
    metaFilesUrl?: string;
    number?: IApplicationNumberSettings;
    numberConverter?: INumberConverterSettingsEntity;
    oauth?: IOAuthSettingsEntity;
    persistenceStorage?: StorageTypesEnum;
    phone?: IPhoneSettingsEntity;
    resourcePaths?: IApplicationResourcePaths;
    routes?: IRoutesSettingsEntity;
    signalRUrl?: string;
    storage?: IStorageSettingsEntity;
    transport?: ITransportSettingsEntity;
    urls?: IUrlsSettingsEntity;
}
export declare const DEFAULT_APPLICATION_SETTINGS: ISettingsEntity;
