import { IReduxMultiEntity, IMultiEntityStorageSetEntity, IMultiItemEntity, IStorage } from '../../definition';
export declare class MultiEntityStorage implements IStorage<IStorage> {
    storage: IStorage;
    private multiEntityProcessor;
    /**
     * @stable [30.07.2019]
     * @param {IStorage} storage
     * @param {(entity: IMultiItemEntity) => Promise<any>} multiEntityProcessor
     */
    constructor(storage: IStorage, multiEntityProcessor?: (entity: IMultiItemEntity) => Promise<any>);
    /**
     * @stable [30.07.2019]
     * @param {string} key
     * @param {IReduxMultiEntity} entity
     * @returns {Promise<IMultiEntityStorageSetEntity>}
     */
    set(key: string, entity: IReduxMultiEntity): Promise<IMultiEntityStorageSetEntity>;
    /**
     * @stable [30.07.2019]
     * @param {IReduxMultiEntity} entity
     * @returns {Promise<AnyT[]>}
     */
    private add;
    /**
     * @stable [30.07.2019]
     * @param {IReduxMultiEntity} entity
     * @returns {Promise<void[]>}
     */
    private clear;
}
