"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeChainedFormMiddleware = void 0;
var action_builder_1 = require("../../component/action.builder");
var util_1 = require("../../util");
var action_1 = require("../../action");
/**
 * @stable [28.08.2019]
 * @param {IChainedFormMiddlewareConfigEntity} config
 * @returns {IEffectsAction[]}
 */
exports.makeChainedFormMiddleware = function (config) {
    return __spreadArrays([
        action_1.StackActionBuilder.buildLockAction(config.nextFormSection),
        // Need to call reset the previous form because "lock". We cannot use destroy because "listeners" + "active value"
        action_1.FormActionBuilder.buildResetAction(config.previousFormSection)
    ], util_1.ifNotNilThanValue(config.nextListSection, 
    // Clear previous created entity applied to the list. We cannot use destroy because "listeners"
    function () { return [action_builder_1.ListActionBuilder.buildResetAction(config.nextListSection)]; }, []), util_1.ifNotNilThanValue(config.nextFormChanges, function () { return [action_1.FormActionBuilder.buildChangesAction(config.nextFormSection, config.nextFormChanges)]; }, []), [
        config.replaceRoute === true
            ? action_1.RouterActionBuilder.buildReplaceAction(config.nextFormRoute)
            : action_1.RouterActionBuilder.buildNavigateAction(config.nextFormRoute)
    ]);
};
//# sourceMappingURL=chained-form.middleware.js.map