"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditedListMiddlewareFactories = exports.makeLazyLoadedEntityMiddleware = exports.makeCreateEntityMiddleware = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var action_builder_1 = require("../../component/action.builder");
var chained_middleware_1 = require("./chained.middleware");
var util_1 = require("../../util");
var default_form_changes_middleware_1 = require("./default-form-changes.middleware");
/**
 * @stable [19.09.2020]
 * @param cfg
 */
var asChainedConfigEntity = function (cfg) {
    return util_1.FilterUtils.defValuesFilter({
        action: cfg.action,
        nextSection: util_1.SectionUtils.asFormSection(cfg),
        path: cfg.path,
        state: cfg.state,
    });
};
/**
 * @stable [04.09.2020]
 * @param config
 */
exports.makeCreateEntityMiddleware = function (config) {
    return util_1.ConditionUtils.ifNotNilThanValue(chained_middleware_1.makeChainedMiddleware(asChainedConfigEntity(config)), function (actions) { return util_1.FilterUtils.notNilValuesArrayFilter.apply(util_1.FilterUtils, __spreadArrays(actions, [default_form_changes_middleware_1.DefaultFormChangesMiddlewareFactories.defaultFormChangesMiddleware(config)])); });
};
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var makeSelectEntityMiddleware = function (cfg) {
    var action = cfg.action;
    var selected = util_1.Selectors.selectedEntityFromAction(action);
    return cfg.lazyLoading
        ? [
            action_builder_1.ListActionBuilder.buildLazyLoadAction(util_1.SectionUtils.asListSection(cfg), util_1.FilterUtils.defValuesFilter({
                selected: selected,
                preventEffects: util_1.Selectors.preventEffectsFromAction(action),
                previousAction: util_1.Selectors.previousActionFromAction(action),
            }))
        ]
        : chained_middleware_1.makeChainedMiddleware(__assign(__assign({}, asChainedConfigEntity(cfg)), { payload: selected }));
};
/**
 * @stable [03.04.2020]
 * @param {IEditedListMiddlewareConfigEntity<TPayload, TState, TDefaultChanges>} config
 * @returns {IEffectsAction[]}
 */
exports.makeLazyLoadedEntityMiddleware = function (config) {
    var action = config.action;
    var result = __spreadArrays(util_1.ConditionUtils.ifNotNilThanValue(util_1.Selectors.previousActionTypeFromAction(action), function (previousActionType) { return [redux_effects_promise_1.EffectsAction.create(redux_effects_promise_1.EffectsActionBuilder.buildDoneActionType(previousActionType))]; }, []), chained_middleware_1.makeChainedMiddleware(__assign(__assign({}, asChainedConfigEntity(config)), { payload: action.data })) || []);
    return util_1.ConditionUtils.orNull(util_1.ObjectUtils.isObjectNotEmpty(result), result);
};
/**
 * @stable [09.09.2020]
 */
var EditedListMiddlewareFactories = /** @class */ (function () {
    function EditedListMiddlewareFactories() {
    }
    EditedListMiddlewareFactories.selectEntityMiddleware = makeSelectEntityMiddleware;
    return EditedListMiddlewareFactories;
}());
exports.EditedListMiddlewareFactories = EditedListMiddlewareFactories;
//# sourceMappingURL=edited-list.middleware.js.map