"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterFormDialogMiddlewareFactories = void 0;
var action_1 = require("../../action");
var loaded_list_middleware_1 = require("./loaded-list.middleware");
var util_1 = require("../../util");
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var makeFilterFormDialogClearMiddleware = function (cfg) {
    return [
        action_1.FormActionBuilder.buildResetAction(util_1.SectionUtils.asFormSection(cfg)),
        loaded_list_middleware_1.LoadedListMiddlewareFactories.loadedListMiddleware(cfg)
    ];
};
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var makeFilterFormDialogResetMiddleware = function (cfg) {
    return action_1.FormActionBuilder.buildResetAction(util_1.SectionUtils.asFormSection(cfg));
};
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var makeFilterFormDialogAcceptMiddleware = function (cfg) {
    return loaded_list_middleware_1.LoadedListMiddlewareFactories.loadedListMiddleware(cfg);
};
/**
 * @stable [09.09.2020]
 */
var FilterFormDialogMiddlewareFactories = /** @class */ (function () {
    function FilterFormDialogMiddlewareFactories() {
    }
    FilterFormDialogMiddlewareFactories.filterFormDialogAcceptMiddleware = makeFilterFormDialogAcceptMiddleware;
    FilterFormDialogMiddlewareFactories.filterFormDialogClearMiddleware = makeFilterFormDialogClearMiddleware;
    FilterFormDialogMiddlewareFactories.filterFormDialogResetMiddleware = makeFilterFormDialogResetMiddleware;
    return FilterFormDialogMiddlewareFactories;
}());
exports.FilterFormDialogMiddlewareFactories = FilterFormDialogMiddlewareFactories;
//# sourceMappingURL=filer-form-dialog.middleware.js.map