import { IEffectsAction } from 'redux-effects-promise';
import { ILoadedListMiddlewareConfigEntity, ILoadedListOnFormValidMiddlewareConfigEntity, ILoadedListOnNavigateToPageMiddlewareConfigEntity, ILoadedListOnTabActivateMiddlewareConfigEntity, ILoadedListOnToolbarToolsRefreshConfigEntity, IUntouchedListMiddlewareConfigEntity } from '../../definition';
/**
 * @stable [09.09.2020]
 * @param config
 */
export declare const makeLoadedListOnFormValidMiddleware: <TState = {}>(config: ILoadedListOnFormValidMiddlewareConfigEntity<TState>) => IEffectsAction;
/**
 * @stable [09.09.2020]
 * @param config
 */
export declare const makeLoadedListOnToolbarToolsRefreshMiddleware: <TState = {}>(config: ILoadedListOnToolbarToolsRefreshConfigEntity<TState>) => IEffectsAction;
/**
 * @stable [09.09.2020]
 * @param cfg
 */
export declare const makeLoadedListOnNavigateToPreviousPageMiddleware: <TState = {}>(cfg: ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => IEffectsAction[];
/**
 * @stable [09.09.2020]
 * @param cfg
 */
export declare const makeLoadedListOnNavigateToNextPageMiddleware: <TState = {}>(cfg: ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => IEffectsAction[];
/**
 * @stable [09.09.2020]
 * @param cfg
 */
export declare const makeLoadedListOnNavigateToFirstPageMiddleware: <TState = {}>(cfg: ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => IEffectsAction[];
/**
 * @stable [09.09.2020]
 * @param cfg
 */
export declare const makeLoadedListOnNavigateToLastPageMiddleware: <TState = {}>(cfg: ILoadedListOnNavigateToPageMiddlewareConfigEntity<TState>) => IEffectsAction[];
/**
 * @stable [09.09.2020]
 */
export declare class LoadedListMiddlewareFactories {
    static readonly loadedListMiddleware: <TState = {}>(cfg: ILoadedListMiddlewareConfigEntity<TState>) => IEffectsAction;
    static readonly loadedListOnTabActivateMiddleware: <TState = {}>(config: ILoadedListOnTabActivateMiddlewareConfigEntity<TState>) => IEffectsAction;
    static readonly untouchedListMiddleware: <TState = {}, TDefaultChanges = {}>(cfg: IUntouchedListMiddlewareConfigEntity<TState, TDefaultChanges>) => IEffectsAction[];
}
