"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StackEffects = void 0;
var redux_effects_promise_1 = require("redux-effects-promise");
var ts_smart_logger_1 = require("ts-smart-logger");
var di_1 = require("../../di");
var action_builder_1 = require("../../component/action.builder");
var action_1 = require("../../action");
var stack_support_1 = require("./stack.support");
var definition_1 = require("../../definition");
var StackEffects = /** @class */ (function () {
    function StackEffects() {
    }
    StackEffects_1 = StackEffects;
    StackEffects.prototype.$onStackPush = function (action, state) {
        var payload = action.data;
        var destroyableSections = stack_support_1.getAllIndependentStackSections(payload.section, state.stack);
        if (destroyableSections.length) {
            StackEffects_1.logger.debug("[$StackEffects][$onStackPush] The sections to destroy: [" + destroyableSections + "]");
            return [action_1.StackActionBuilder.buildRemoveAction.apply(action_1.StackActionBuilder, destroyableSections)]
                .concat(this.buildActionsToDestroy(destroyableSections));
        }
        return null;
    };
    StackEffects.prototype.buildActionsToDestroy = function (sectionsToDestroy) {
        return sectionsToDestroy.map(function (section) { return action_builder_1.ListActionBuilder.buildDestroyAction(section); })
            .concat(sectionsToDestroy.map(function (section) { return action_1.FormActionBuilder.buildDestroyAction(section); }))
            .concat(sectionsToDestroy.map(function (section) { return action_1.FilterActionBuilder.buildDestroyAction(section); }))
            .concat(sectionsToDestroy.map(function (section) { return action_1.TabPanelActionBuilder.buildDestroyAction(section); }));
    };
    var StackEffects_1;
    StackEffects.logger = ts_smart_logger_1.LoggerFactory.makeLogger('StackEffects');
    __decorate([
        redux_effects_promise_1.EffectsService.effects(definition_1.$RAC_STACK_PUSH_ACTION_TYPE),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object, Object]),
        __metadata("design:returntype", Array)
    ], StackEffects.prototype, "$onStackPush", null);
    StackEffects = StackEffects_1 = __decorate([
        di_1.provideInSingleton(StackEffects_1)
    ], StackEffects);
    return StackEffects;
}());
exports.StackEffects = StackEffects;
//# sourceMappingURL=stack.effects.js.map