"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlobUtils = exports.detectBlobMimeType = exports.getBlobMimeType = exports.readBlobBytesAsString = exports.readBlobBytes = void 0;
var definition_1 = require("../definition");
var nvl_1 = require("./nvl");
/**
 * @stable [09.11.2020]
 * @param base64
 * @param options
 */
var fromBase64UrlToBlob = function (base64, options) {
    return fromUrlToBlob("data:image;base64," + base64, options);
};
/**
 * @stable [02.11.2020]
 * @param url
 * @param options
 */
var fromUrlToBlob = function (url, options) {
    return fetch(url, __assign({ mode: 'cors' }, options)).then(function (r) { return r.blob(); });
};
/**
 * @stable [04.08.2019]
 * @param {Blob} blob
 * @param {number} length
 * @returns {Promise<number[]>}
 */
exports.readBlobBytes = function (blob, length) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve) {
                var fileReader = new FileReader();
                fileReader.onloadend = function (evt) {
                    var target = evt.target;
                    if (target.readyState === FileReader.DONE) {
                        resolve(Array.from(new Uint8Array(target.result)));
                    }
                };
                fileReader.readAsArrayBuffer(blob.slice(0, nvl_1.nvl(length, blob.size)));
            })];
    });
}); };
/**
 * @stable [04.08.2019]
 * @param {Blob} blob
 * @param {number} length
 * @returns {Promise<string>}
 */
exports.readBlobBytesAsString = function (blob, length) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, exports.readBlobBytes(blob, length)
                .then(function (bytes) { return bytes.map(function (byte) { return byte.toString(16); }).join('').toUpperCase(); })];
    });
}); };
/**
 * @stable [04.08.2019]
 * @param {string} signature
 * @returns {MimeTypesEnum | string}
 */
exports.getBlobMimeType = function (signature) {
    switch (signature) {
        case '89504E47':
            return definition_1.MimeTypesEnum.IMAGE_PNG;
        case '47494638':
            return 'image/gif';
        case '25504446':
            return definition_1.MimeTypesEnum.APPLICATION_PDF;
        case 'FFD8FFDB':
        case 'FFD8FFE0':
            return definition_1.MimeTypesEnum.IMAGE_JPEG;
        case '504B0304':
            return 'application/zip';
        default:
            return null;
    }
};
/**
 * @stable [19.09.2019]
 * @param {Blob} blob
 * @returns {Promise<MimeTypesEnum | string>}
 */
exports.detectBlobMimeType = function (blob) { return __awaiter(void 0, void 0, void 0, function () {
    var bytes;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.readBlobBytesAsString(blob, 4)];
            case 1:
                bytes = _a.sent();
                return [2 /*return*/, exports.getBlobMimeType(bytes)];
        }
    });
}); };
/**
 * @stable [02.11.2020]
 */
var BlobUtils = /** @class */ (function () {
    function BlobUtils() {
    }
    BlobUtils.fromBase64UrlToBlob = fromBase64UrlToBlob;
    BlobUtils.fromUrlToBlob = fromUrlToBlob;
    return BlobUtils;
}());
exports.BlobUtils = BlobUtils;
//# sourceMappingURL=blob.js.map