"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MapAsOriginalUtils = void 0;
var select_1 = require("./select");
var map_as_wrapper_1 = require("./map-as-wrapper");
var definitions_interface_1 = require("../definitions.interface");
var filter_1 = require("./filter");
var cond_1 = require("./cond");
/**
 * @map-as-original
 *
 * @stable [02.08.2020]
 * @param entity
 */
var mapSelectOptionEntity = function (entity) {
    return cond_1.ConditionUtils.ifNotNilThanValue(entity, function () { return filter_1.FilterUtils.defValuesFilter({
        disabled: entity.disabled,
        label: entity.label,
        rawData: entity.rawData,
        value: entity.value,
    }); }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapLifeCycleEntity = function (entity) {
    return cond_1.ConditionUtils.ifNotNilThanValue(entity, function () { return filter_1.FilterUtils.defValuesFilter({
        error: entity.error,
        progress: entity.progress,
        touched: entity.touched,
    }); }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @map-as-original
 *
 * @stable [27.07.2020]
 * @param extendedEntity
 */
var mapExtendedEntity = function (extendedEntity) {
    return cond_1.ConditionUtils.ifNotNilThanValue(extendedEntity, function () { return filter_1.FilterUtils.defValuesFilter({
        changes: extendedEntity.changes,
        entity: extendedEntity.entity,
        entityId: extendedEntity.entityId,
        newEntity: extendedEntity.newEntity,
        originalEntity: extendedEntity.originalEntity,
    }); }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapPagedEntity = function (entity) {
    return cond_1.ConditionUtils.ifNotNilThanValue(entity, function () { return filter_1.FilterUtils.defValuesFilter({
        page: entity.page,
        pageSize: entity.pageSize,
    }); }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapPaginatedEntity = function (entity) {
    return cond_1.ConditionUtils.ifNotNilThanValue(entity, function () { return filter_1.FilterUtils.defValuesFilter(__assign(__assign({}, mapPagedEntity(entity)), { lockPage: entity.lockPage, totalAmount: entity.totalAmount, totalCount: entity.totalCount })); }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapQueryFilterEntity = function (entity) {
    return cond_1.ConditionUtils.ifNotNilThanValue(entity, function () { return filter_1.FilterUtils.defValuesFilter({
        active: entity.active,
        query: entity.query,
    }); }, definitions_interface_1.UNDEF_SYMBOL);
};
/**
 * @map-as-original
 *
 * @stable [29.07.2020]
 * @param entity
 */
var mapTabPanelHolderEntity = function (entity) {
    return map_as_wrapper_1.MapAsWrapperUtils.tabPanel(select_1.Selectors.tabPanel(entity));
};
/**
 * @map-as-original
 *
 * @stable [30.07.2020]
 * @param entity
 */
var mapActiveValueHolderEntity = function (entity) {
    return map_as_wrapper_1.MapAsWrapperUtils.activeValue(select_1.Selectors.activeValue(entity));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapPaginatedLifeCycleEntity = function (entity) { return (__assign(__assign({}, mapLifeCycleEntity(entity)), mapPaginatedEntity(entity))); };
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapQueryFilterHolderEntity = function (entity) {
    return map_as_wrapper_1.MapAsWrapperUtils.queryFilter(select_1.Selectors.queryFilter(entity));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param wrapper
 */
var mapUserHolderEntity = function (wrapper) {
    return map_as_wrapper_1.MapAsWrapperUtils.user(select_1.Selectors.user(wrapper));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param wrapper
 */
var mapStackHolderEntity = function (wrapper) {
    return map_as_wrapper_1.MapAsWrapperUtils.stack(select_1.Selectors.stack(wrapper));
};
/**
 * @map-as-original
 *
 * @stable [26.07.2020]
 * @param wrapper
 */
var mapSectionNameWrapper = function (wrapper) {
    return map_as_wrapper_1.MapAsWrapperUtils.sectionName(select_1.Selectors.sectionName(wrapper));
};
/**
 * @map-as-original
 *
 * @stable [10.08.2020]
 * @param wrapper
 */
var mapProgressWrapper = function (wrapper) {
    return map_as_wrapper_1.MapAsWrapperUtils.progress(select_1.Selectors.progress(wrapper));
};
/**
 * @map-as-original
 *
 * @stable [30.07.2020]
 * @param entity
 */
var mapFormHolderEntity = function (entity) {
    return map_as_wrapper_1.MapAsWrapperUtils.form(select_1.Selectors.form(entity));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param wrapper
 */
var mapLayoutHolderEntity = function (wrapper) {
    return map_as_wrapper_1.MapAsWrapperUtils.layout(select_1.Selectors.layout(wrapper));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapChannelHolderEntity = function (entity) {
    return map_as_wrapper_1.MapAsWrapperUtils.channel(select_1.Selectors.channel(entity));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param wrapper
 */
var mapDictionariesHolderEntity = function (wrapper) {
    return map_as_wrapper_1.MapAsWrapperUtils.dictionaries(select_1.Selectors.dictionaries(wrapper));
};
/**
 * @map-as-original
 *
 * @stable [30.07.2020]
 * @param entity
 */
var mapNotificationHolderEntity = function (entity) {
    return map_as_wrapper_1.MapAsWrapperUtils.notification(select_1.Selectors.notification(entity));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapTransportHolderEntity = function (entity) {
    return map_as_wrapper_1.MapAsWrapperUtils.transport(select_1.Selectors.transport(entity));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapListHolderEntity = function (entity) { return map_as_wrapper_1.MapAsWrapperUtils.list(select_1.Selectors.list(entity)); };
/**
 * @map-as-original
 *
 * @stable [01.08.2020]
 * @param form
 */
var mapExtendedFormEntity = function (form) { return (__assign(__assign({}, mapExtendedEntity(form)), mapFormHolderEntity(form))); };
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapStoreBaseEntity = function (entity) {
    return (__assign(__assign(__assign(__assign({}, mapChannelHolderEntity(entity)), mapDictionariesHolderEntity(entity)), mapNotificationHolderEntity(entity)), mapTransportHolderEntity(entity)));
};
/**
 * @map-as-original
 *
 * @stable [31.07.2020]
 * @param entity
 */
var mapStoreEntity = function (entity) {
    return (__assign(__assign(__assign(__assign({}, mapStoreBaseEntity(entity)), mapLayoutHolderEntity(entity)), mapStackHolderEntity(entity)), mapUserHolderEntity(entity)));
};
/**
 * @stable [27.07.2020]
 */
var MapAsOriginalUtils = /** @class */ (function () {
    function MapAsOriginalUtils() {
    }
    MapAsOriginalUtils.activeValueHolderEntity = mapActiveValueHolderEntity;
    MapAsOriginalUtils.extendedEntity = mapExtendedEntity;
    MapAsOriginalUtils.extendedFormEntity = mapExtendedFormEntity;
    MapAsOriginalUtils.formHolderEntity = mapFormHolderEntity;
    MapAsOriginalUtils.listHolderEntity = mapListHolderEntity;
    MapAsOriginalUtils.pagedEntity = mapPagedEntity;
    MapAsOriginalUtils.paginatedEntity = mapPaginatedEntity;
    MapAsOriginalUtils.paginatedLifeCycleEntity = mapPaginatedLifeCycleEntity;
    MapAsOriginalUtils.progressWrapper = mapProgressWrapper;
    MapAsOriginalUtils.queryFilterEntity = mapQueryFilterEntity;
    MapAsOriginalUtils.queryFilterHolderEntity = mapQueryFilterHolderEntity;
    MapAsOriginalUtils.sectionNameWrapper = mapSectionNameWrapper;
    MapAsOriginalUtils.selectOptionEntity = mapSelectOptionEntity;
    MapAsOriginalUtils.storeBaseEntity = mapStoreBaseEntity;
    MapAsOriginalUtils.storeEntity = mapStoreEntity;
    MapAsOriginalUtils.tabPanelHolderEntity = mapTabPanelHolderEntity;
    return MapAsOriginalUtils;
}());
exports.MapAsOriginalUtils = MapAsOriginalUtils;
//# sourceMappingURL=map-as-original.js.map