import { IMultiFieldValueConcatConfigEntity, IMultiFieldValueFilterConfigEntity, IMultiFieldValueMergeConfigEntity, IMultiItemEntity, IReduxMultiEntity, MultiFieldValueOrEntitiesIdsT, MultiFieldValueOrEntityIdT, MultiFieldValueT, NotMultiFieldValueT } from '../definition';
import { EntityIdT, IEntity } from '../definitions.interface';
/**
 * @stable [07.11.2020]
 * @param entity
 * @param keyAccessor
 */
export declare const multiFieldValueEntitiesAsTrueValuesObject: <TEntity extends IEntity = IEntity>(entity: MultiFieldValueT<TEntity>, keyAccessor?: (item: TEntity) => EntityIdT) => Record<EntityIdT, boolean>;
/**
 * @stable [29.08.2020]
 */
export declare class MultiFieldUtils {
    static readonly asMultiItemEntity: <TEntity extends IEntity = IEntity>(name: string, value: unknown, rawData: TEntity, newEntity?: boolean) => IMultiItemEntity;
    static readonly concatMultiFieldValue: <TEntity extends IEntity>(cfg: IMultiFieldValueConcatConfigEntity<TEntity>) => IReduxMultiEntity<IEntity>;
    static readonly extractEntitiesFromMultiFieldValue: (value: MultiFieldValueT<IEntity>, converter: (value: IReduxMultiEntity<IEntity>) => IMultiItemEntity[], defaultValue: IEntity[]) => IEntity[] | IMultiItemEntity[];
    static readonly filterMultiFieldValue: <TEntity extends IEntity>(cfg: IMultiFieldValueFilterConfigEntity<TEntity>) => IReduxMultiEntity<IEntity>;
    static readonly fromMultiEntity: <TEntity extends IEntity = IEntity>(initial: IReduxMultiEntity<TEntity>) => IReduxMultiEntity<TEntity>;
    static readonly isNotMultiEntity: (value: MultiFieldValueOrEntityIdT) => boolean;
    static readonly multiFieldValueAsEditEntities: <TEntity extends IEntity = IEntity>(entity: MultiFieldValueT<TEntity>, mappedSourcedItems?: Map<import("../definitions.interface").StringNumberT, TEntity>) => TEntity[];
    static readonly multiFieldValueAsEntities: <TEntity extends IEntity = IEntity>(entity: MultiFieldValueT<TEntity>) => TEntity[];
    static readonly multiFieldValueAsEntitiesIds: <TEntity extends IEntity = IEntity>(multiFieldEntity: MultiFieldValueOrEntitiesIdsT<TEntity>) => import("../definitions.interface").StringNumberT[];
    static readonly multiFieldValueAsMappedEntities: <TEntity extends IEntity = IEntity, TResult = TEntity>(multiFieldEntity: MultiFieldValueT<TEntity>, mapper: (entity: TEntity, index: number) => TResult) => TResult[];
    static readonly multiFieldValueAsMergedTrueEntities: <TEntity extends IEntity>(cfg: IMultiFieldValueMergeConfigEntity<TEntity>) => Record<import("../definitions.interface").StringNumberT, boolean>;
    static readonly multiFieldValueAsMultiItemAddEntities: (value: MultiFieldValueT<IEntity>, defaultValue?: IEntity[]) => IEntity[];
    static readonly multiFieldValueAsMultiItemEditEntities: (value: MultiFieldValueT<IEntity>, defaultValue?: IEntity[]) => IMultiItemEntity[];
    static readonly multiFieldValueAsMultiItemRemoveEntities: (value: MultiFieldValueT<IEntity>, defaultValue?: IEntity[]) => IEntity[];
    static readonly multiFieldValueEntitiesAsTrueValuesObject: <TEntity extends IEntity = IEntity>(entity: MultiFieldValueT<TEntity>, keyAccessor?: (item: TEntity) => import("../definitions.interface").StringNumberT) => Record<import("../definitions.interface").StringNumberT, boolean>;
    static readonly notMultiFieldValueAsEntities: <TEntity extends IEntity = IEntity>(value: NotMultiFieldValueT<TEntity>) => TEntity[];
}
