import { StringNumberT, IKeyValue } from '../definitions.interface';
/**
 * @stable [28.01.2019]
 * @param {string} before
 * @param {string} after
 * @returns {(matchedValue: string) => string}
 */
export declare const replacerFactory: (before: string, after: string) => (matchedValue: string) => string;
/**
 * @stable [28.01.2019]
 * @type {(matchedValue: string) => string}
 */
export declare const htmlStrongReplacer: (matchedValue: string) => string;
/**
 * @stable [05.05.2020]
 * @param {StringNumberT} inputValue
 * @param {string} replacedValue
 * @param {(...matchedValue: string[]) => string} replacer
 * @param {string} flags
 * @returns {string}
 */
export declare const regexpReplace: (inputValue: StringNumberT, replacedValue: string, replacer: (...matchedValue: string[]) => string, flags?: string) => string;
/**
 * @stable [05.05.2020]
 * @param {string} value
 * @param {IKeyValue} parameters
 * @returns {string}
 */
export declare const replaceByParameters: (value: string, parameters?: IKeyValue) => string;
/**
 * @stable [28.01.2019]
 * @param {StringNumberT} inputValue
 * @param {string} replacedValue
 * @returns {string}
 */
export declare const strongHtmlReplace: (inputValue: StringNumberT, replacedValue: string) => string;
