"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SectionUtils = void 0;
var definitions_interface_1 = require("../definitions.interface");
var calc_1 = require("./calc");
var cond_1 = require("./cond");
var filter_1 = require("./filter");
var nvl_1 = require("./nvl");
var type_1 = require("./type");
/**
 * @stable [08.09.2020]
 * @param section
 * @param data
 */
var applySection = function (section, data) {
    return (__assign({ section: section }, (cond_1.ConditionUtils.ifNotEmptyThanValue(data, function () { return (Array.isArray(data)
        ? type_1.TypeUtils.asType({ data: data })
        : data); }))));
};
/**
 * @stable [26.07.2020]
 * @param section
 */
var actionPrefix = function (section) { return "" + definitions_interface_1.ACTION_PREFIX + section; };
/**
 * @stable [09.09.2020]
 * @param section
 * @param cfg
 */
var asConfigSection = function (section, cfg) {
    return calc_1.CalcUtils.calc(section, filter_1.FilterUtils.defValuesFilter({ action: cfg.action, state: cfg.state }));
};
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var asListSection = function (cfg) {
    return asConfigSection(cfg.listSection, cfg);
};
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var asContainerSection = function (cfg) {
    return asConfigSection(cfg.containerSection, cfg);
};
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var asFormSection = function (cfg) {
    return asConfigSection(cfg.formSection, cfg);
};
/**
 * @stable [09.09.2020]
 * @param cfg
 */
var asFormOrListSection = function (cfg) {
    return nvl_1.NvlUtils.nvl(asFormSection(cfg), asListSection(cfg));
};
/**
 * @stable [22.09.2020]
 * @param cfg
 */
var asTabPanelSection = function (cfg) {
    return asConfigSection(cfg.tabPanelSection, cfg);
};
/**
 * @stable [26.07.2020]
 */
var SectionUtils = /** @class */ (function () {
    function SectionUtils() {
    }
    SectionUtils.actionPrefix = actionPrefix;
    SectionUtils.applySection = applySection;
    SectionUtils.asContainerSection = asContainerSection;
    SectionUtils.asFormOrListSection = asFormOrListSection;
    SectionUtils.asFormSection = asFormSection;
    SectionUtils.asListSection = asListSection;
    SectionUtils.asTabPanelSection = asTabPanelSection;
    return SectionUtils;
}());
exports.SectionUtils = SectionUtils;
//# sourceMappingURL=section.js.map