"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectOptionUtils = void 0;
var R = require("ramda");
var definitions_interface_1 = require("../definitions.interface");
var type_1 = require("./type");
var di_services_1 = require("../di/di.services");
/**
 * 02.11.2020
 * @param option
 */
var fromSelectValueToId = function (option) {
    if (R.isNil(option)) {
        return option;
    }
    if (type_1.TypeUtils.isPrimitive(option)) {
        return option;
    }
    var optionAsObject = option;
    return optionAsObject.value;
};
/**
 * 02.11.2020
 * @param option
 */
var fromSelectValueToRawValue = function (option) {
    if (R.isNil(option)) {
        return option;
    }
    if (type_1.TypeUtils.isPrimitive(option)) {
        return definitions_interface_1.UNDEF;
    }
    var rawData = option.rawData;
    return rawData;
};
/**
 * 02.11.2020
 * @param option
 */
var fromSelectValueToDisplayValue = function (option) {
    if (R.isNil(option)) {
        return option;
    }
    if (type_1.TypeUtils.isPrimitive(option)) {
        return option;
    }
    var label = option.label;
    return R.isNil(label)
        ? fromSelectValueToId(option)
        : di_services_1.DiServices.translator()(label, option);
};
/**
 * @stable [02.11.2020]
 */
var SelectOptionUtils = /** @class */ (function () {
    function SelectOptionUtils() {
    }
    SelectOptionUtils.fromSelectValueToDisplayValue = fromSelectValueToDisplayValue; /* @stable [02.11.2020] */
    SelectOptionUtils.fromSelectValueToId = fromSelectValueToId; /* @stable [02.11.2020] */
    SelectOptionUtils.fromSelectValueToRawValue = fromSelectValueToRawValue; /* @stable [02.11.2020] */
    return SelectOptionUtils;
}());
exports.SelectOptionUtils = SelectOptionUtils;
//# sourceMappingURL=select-option.js.map